## How to contribute to language-ext

#### **Did you find a bug?**

* **Ensure the bug was not already reported** by searching on GitHub under [Issues](https://github.com/louthy/language-ext/issues).

* If you're unable to find an open issue addressing the problem, [open a new one](https://github.com/louthy/language-ext/issues/new). Be sure to include a **title and clear description**, as much relevant information as possible, and a **code sample** or an **executable test case** demonstrating the expected behavior that is not occurring.

#### **Did you write a patch that fixes a bug?**

* Open a new GitHub pull request with the patch.

* Ensure the PR description clearly describes the problem and solution. Include the relevant issue number if applicable.

#### **Do you intend to add a new feature or change an existing one?**

* First suggest your change in the [language-ext issues page](https://github.com/louthy/language-ext/issues).

* There are no fixed rules on what should and shouldn't be in this library, but some features are more valuable than others, and some require long-term maintenance that outweighs the value of the feature. So please get sign-off from the project leader (Paul Louth) before putting in an excessive amount of work.

#### **Do you have questions about the source code?**

* Ask any question about how to use language-ext in the [language-ext issues page](https://github.com/louthy/language-ext/issues).

#### **Do you want to contribute to the language-ext documentation?**

This is very welcome:

* The APi documentation is generated from the source code - please make sure you use back-tick markdown code-blocks within `<summary>...</summary>` and other XmlDoc sections for variable, method, or type-names and code-examples.  If unclear, ask on the [language-ext issues page](https://github.com/louthy/language-ext/issues)

* The [language-ext wiki](https://github.com/louthy/language-ext/wiki) is always crying out for general usage examples.  If you want to talk about a larger subject that is enabled by language-ext (like parsing for example), then clear it first on the [language-ext issues page](https://github.com/louthy/language-ext/issues).

Thanks! :heart: :heart: :heart:

Paul Louth
